package de.intevation.gnv.math;

import com.vividsolutions.jts.geom.MultiLineString;
import com.vividsolutions.jts.geom.MultiPolygon;

import de.intevation.gnv.utils.Pair;

import java.io.Serializable;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *  @author <a href="mailto:sascha.teichmann@intevation.de">Sascha L. Teichmann</a>
 */
public class AttributedPoint2ds
implements   Serializable
{
    protected List<? extends Point2d>             points;
    protected Map                                 attributes;
    protected AreaInterpolation                   interpolation;
    protected List<Pair<Object, MultiLineString>> lineStrings;
    protected Map<Integer, MultiPolygon>          polygons;

    public AttributedPoint2ds() {
    }

    public AttributedPoint2ds(List<? extends Point2d> points) {
        this.points = points;
    }

    public Object getAttribute(Object key) {
        return attributes != null
            ? attributes.get(key)
            : null;
    }

    public void setAttribute(Object key, Object value) {
        if (attributes == null) {
            attributes = new HashMap();
        }
        attributes.put(key, value);
    }

    public List<? extends Point2d> getPoints() {
        return points;
    }

    public void setPoints(List<? extends Point2d> points) {
        this.points = points;
    }

    public void setInterpolation(AreaInterpolation interpolation) {
        this.interpolation = interpolation;
    }

    public AreaInterpolation getInterpolation() {
        return interpolation;
    }

    public void setPolygons(Map<Integer, MultiPolygon> polygons) {
        this.polygons = polygons;
    }

    public Map<Integer, MultiPolygon> getPolygons() {
        return polygons;
    }

    public void setLineStrings(
        List<Pair<Object, MultiLineString>> lineStrings
    ) {
        this.lineStrings = lineStrings;
    }

    public List<Pair<Object, MultiLineString>> getLineStrings() {
        return lineStrings;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
